app/lib/app_web/router.ex
defmodule AppWeb.Router do
  use AppWeb, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :api do
    plug :accepts, ["json"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :auth do
    plug AppWeb.Plugs.Auth.Pipeline
  end

  pipeline :ensure_auth do
    plug Guardian.Plug.EnsureAuthenticated
  end

  scope "/", AppWeb do
    pipe_through [:browser, :auth]

    get "/", SessionController, :new
    get "/logout", SessionController, :logout
    post "/login", SessionController, :login

    pipe_through :ensure_auth
    get "/dashboard", DashboardController, :index
    get "/roads", RoadController, :index
    scope "/settings" do
      get "/", SettingsController, :index
      get "/user", SettingsController, :new_user
      post "/user", SettingsController, :create_user
      post "/user/:id/delete", SettingsController, :delete_user
      get "/user/:id/edit", SettingsController, :edit_user
      put "/user/:id", SettingsController, :update_user
      get "/user/:id/password", SettingsController, :change_password
    end

    post "/settings/configuration", SettingsController, :load_configuration
    post "/settings/configuration/remove", SettingsController, :remove_configuration
  end

  scope "/api", AppWeb do
    pipe_through [:api, :auth, :ensure_auth]
    get "/map", ApiController, :map
    get "/lane-info/:lane_id", ApiController, :lane
    get "/lane-history/:lane_id", ApiController, :lane_history
  end

  # Other scopes may use custom stacks.
  # scope "/api", AppWeb do
  #   pipe_through :api
  # end
end

app/lib/app_web/views/components_view.ex
defmodule AppWeb.ComponentsView do
  use AppWeb, :view
end

app/lib/app_web/templates/components/alerts.html.eex
<p class="alert alert-info" role="alert" onclick="set_d_none(this)"><%= get_flash(@conn, :info) %></p>
<p class="alert alert-danger" role="alert" onclick="set_d_none(this)"><%= get_flash(@conn, :error) %></p>
<p class="alert alert-success" role="alert" onclick="set_d_none(this)"><%= get_flash(@conn, :success)  %></p>
<script>
    function set_d_none(obj){
        obj.classList.add("d-none");
    }
</script>

app/lib/app_web/templates/components/sidebar.html.eex
<div class="sidebar-container">
    <ul class="sidebar-list">
        <%= if "dashboard" == to_string(Enum.at(@conn.path_info, 0)) do %>
        <li class="active"><a href="<%= Routes.dashboard_path(@conn, :index) %>"><i class="fa fa-tachometer"></i> Dashboard</a></li>
        <% else %>
        <li><a href="<%= Routes.dashboard_path(@conn, :index) %>"><i class="fa fa-tachometer"></i> Dashboard</a></li>
        <% end %>

        <%= if "roads" == to_string(Enum.at(@conn.path_info, 0)) do %>
        <li class="active"><a href="<%= Routes.road_path(@conn, :index) %>"><i class="fa fa-road"></i> Roads</a></li>
        <% else %>
        <li><a href="<%= Routes.road_path(@conn, :index) %>"><i class="fa fa-road"></i> Roads</a></li>
        <% end %>
        <%= if Guardian.Plug.current_resource(@conn).role_id == 1 do %>
            <%= if "settings" == to_string(Enum.at(@conn.path_info, 0)) do %>
            <li class="active"><a href="<%= Routes.settings_path(@conn, :index) %>"><i class="fa fa-wrench"></i> Settings</a></li>
            <% else %>
            <li><a href="<%= Routes.settings_path(@conn, :index) %>"><i class="fa fa-wrench"></i> Settings</a></li>
            <% end %>
        <% end %>
    </ul>
    <p>Version: 2.0</p>
</div>

app/lib/app_web/templates/components/topbar.html.eex
<div class="topbar-container">
    <img src="<%= Routes.static_path(@conn, "/images/logo_alt.png") %>" alt="">
    <div class="topbar-container-user">
        <a href="#"><%= Guardian.Plug.current_resource(@conn).username %></a>
        <a href="<%= Routes.session_path(@conn, :logout) %>"><i class="fa fa-sign-out"></i></a>
    </div>
</div>